﻿Type=Class
Version=1.21
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private myFTP As FTP
	Private myAction As String
	Private ftpStatus As String
	Private myTimer As Timer
	Private myHud As HUD
	Private ftpJobs As List
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (server As String,port As Int,user As String,password As String,ftppath As String,action As String)

	' init vars 
	myAction = action ' action request 
	ftpStatus = "WP" ' status work in progress

	' timer for refresh
	myTimer.Initialize("tim",1)
	myTimer.Enabled = True
	myHud.ProgressDialogShow("Attendere prego ...")

	' Action	
	Select Case myAction
	Case "Download" ' name of action into action parameter of initialize class
		Dim myFTP As FTP
		myFTP.Initialize("FTP",server,port,user,password)
		myFTP.List(ftppath)		
	End Select


End Sub

Sub ftp_ListCompleted (ServerPath As String, Success As Boolean, Folders() As FTPEntry, Files() As FTPEntry)
	If Success Then
		Select Case myAction
		Case "Download"
			ftpJobs.Initialize
			For i = 0 To Files.Length - 1        
        		ftpJobs.add(Files(i).Name)
			Next
			If ftpJobs.Size = 0 Then
				ftpStatus = "NF" ' no files found exit	
			Else
				If File.Exists(File.DirDocuments & ServerPath ,ftpJobs.Get(0)) Then
					File.Delete(File.DirDocuments & ServerPath ,ftpJobs.Get(0))
				End If
				myHud.ProgressDialogShow("Download file " & ftpJobs.Get(0)) 	
				myFTP.DownloadFile(ServerPath & ftpJobs.Get(0), False, File.DirDocuments, ftpJobs.Get(0))
			End If
		End Select
	Else
		ftpStatus = "ER" ' Error
	End If
End Sub

Sub FTP_DownloadCompleted (ServerPath As String, Success As Boolean)	
	''''''''''''''''''''''''''''''''''''''''
	' in debug this lines not serve
	'For i = 0 To 100000000
	'Next
	''''''''''''''''''''''''''''''''''''''''
	Select Case myAction
	Case "Download"
		If (ftpJobs.Size-1) > 0 Then
			ftpJobs.RemoveAt(0)
			myHud.ProgressDialogShow("Download file " & ftpJobs.Get(0))
			myFTP.DownloadFile(ServerPath & ftpJobs.Get(0), False, File.DirDocuments, ftpJobs.Get(0))	
		Else
			ftpStatus = "END" ' End of work 
		End If
	End Select
End Sub

Sub tim_tick			
	Select Case ftpStatus
	Case "WP" 'work in progress
		myTimer.Initialize("tim",1)
		myTimer.Enabled = True
	Case "END" 'fine lavoro
		myTimer.Enabled = False
		myHud.ProgressDialogHide
		Select Case myAction
		Case "Download"
			Msgbox("Download ended","Server FTP")
		End Select
	Case "NF" 'no files
		myTimer.Enabled = False
		myHud.ProgressDialogHide
		Msgbox("No files to download found.","Server FTP")		
	Case "ER" 'errors
		myHud.ProgressDialogHide
		myTimer.Enabled = False
		Msgbox("Errors","Server FTP")
	End Select
End Sub
